\ This software is free for use and modification by anyone for any purpose
\ with no restrictions or source identification of any kind.

\ Jul 2016 Douglas B. Hoffman
\ dhoffman888@gmail.com


0 value base-ptr
0 value ptr-size
0 value max-ptr

variable current-ptr  

: allocate-region ( n -- )
  dup to ptr-size allocate throw to base-ptr
  base-ptr current-ptr !
  base-ptr ptr-size + to max-ptr ;


: region-dispose base-ptr free throw region-off
  0 to base-ptr
  0 to ptr-size
  0 to max-ptr
  0 current-ptr !
;  
 
: allocate-r ( n -- ptr )
  aligned \ required
  current-ptr @ >r
  current-ptr +! 
  current-ptr @ max-ptr > abort" region size exceeded"
  r> ;

: newsize-r \ { n-new old-ptr n-old -- ptr }
  >r >r
  ( n-new ) allocate-r dup
  r> swap r> move ;



: noop ;

: region-on ( n -- )
  allocate-region
  ['] allocate-r is allocate'
  ['] drop       is free'
  ['] newsize-r  is newsize'
  ['] noop       is throw'
  ;


: region-reset
  base-ptr current-ptr ! ;

: .regMemUsed current-ptr @ base-ptr - . ." bytes " ; 


3000000 region-on  \ a large region to run the supplied test file